#ifndef utilsH
#define utilsH

#include <GL/glut.h>
#include "glm.h"
#include "loadpic.h"
#define PI 3.14159265

typedef struct TInfo {
  bool fullscreen;                       // jsme ve fs?
  bool showfps;                             // zobrazujem info?
  bool textured;
  bool filled;
  bool clip;    // prochazeni zdi
  bool mouseCheck;
  int windowCenterX,windowCenterY;            // streda okna
  GLint terce[3][6];   // zobrazeny terce 0-vubec 1-ok 2-lezi
  int tmpi1,tmpi2;
  float tmpf1,tmpf2;
};

extern TInfo info;

void onCommand(int command);
void createMenu(void);

void toggleFullScreen(void);

float elapsed(void);
void printText(int x, int y, char* s);

void initTextury();

class TZbran {
  private:
    GLMmodel *point;
  public:
    bool visible;
    void kresli();
    TZbran();  
    ~TZbran();
};

class TTerc
{
  private:
    GLMmodel *point;
  public:
    void kresli(bool stoji=true);
    TTerc();  
    ~TTerc();
};

class TStrelnice
{
  private:
    GLMmodel *point;
  public:
    void kresli();
    TStrelnice();  
    ~TStrelnice();
};

struct TObjekt {
  GLdouble x1,x2,y1,y2;
};

class TClovek
{
  public:
    TObjekt mapaOut,mapaIn;
    GLdouble fov,nearPlane,farPlane;
    GLdouble posX,posY; // pozice ve 2d mape
    GLdouble posXlast,posYlast;
    GLdouble posZ; // skrceni
    GLdouble posAlfa,posBeta; // kam kouka z 2d pozice v radianech
    GLdouble posAlfaD,posBetaD; //alfa a beta ve stupnich
    GLdouble speed,sensi,daleko,accel; 
    GLdouble eyeX,eyeY,eyeZ; // kamera ve 3d
    GLdouble centerX,centerY,centerZ; // kamera ve 3d kouka
    TClovek();
    void setSpeed(GLdouble kolik=3) {speed=kolik;};
    void setSensitivity(GLdouble kolik=0.001) {sensi=kolik;};    
    void setDaleko(GLdouble kolik=100) {daleko=kolik;};
    void prepocitejAll();
    bool jdiY(bool smer=true, bool acc=false);  // chuze dopredu
    bool jdiX(bool smer=true, bool acc=false);  // strafovani
    bool jdiZ(bool smer=true);  // skok/skrceni
    void otocX(bool smer=true, int kolik=1); //rozhlizeni doleva/doprava
    bool otocZ(bool smer=true, int kolik=1); // rozhlizeni nahoru/dolu
};

int rnd(int range);

void initNewGame(int pocet=5);

#endif
